﻿unit rsa_u;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  mp_types, mp_base, mp_numth;

type

  { TMForm }

  TMForm = class(TForm)
    b_d: TButton;
    e_uncrpt: TEdit;
    e_crtm: TEdit;
    e_a: TEdit;
    e_mes: TEdit;
    e_p: TEdit;
    e_q: TEdit;
    l_alp: TLabel;
    l_m: TLabel;
    l_mes: TLabel;
    l_other: TLabel;
    l_p: TLabel;
    l_q: TLabel;
    Memo1: TMemo;
    procedure b_dClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  MForm: TMForm;

implementation

{$R *.lfm}

{ TMForm }

var alph,
    mess : string;


function i2s(i:longint):string;begin str(i,i2s);end;                        // integer to string
function s2i(str:string):longint;var t:integer;begin val(str,s2i,t);end;    // string to integer

function nod(a1,b1:longint):longint;
begin
  while(a1<>b1)do
   if(a1>b1)
   then a1:=a1-b1
   else b1:=b1-a1;
  nod:=a1;
end;

function Pow(A,St:longint):longint;
var i: longint;
begin
  Pow:=1;
  if(St=0)
  then Pow:=1
  else
    for i:=1 to St do Pow := Pow * A;
end;

function find_in_a(c:char):byte;
var i:byte;
begin
   find_in_a:=0;
   for i:=1 to 255 do
    if(alph[i]=c)then
    begin
       find_in_a:=i;
       break;
    end;
end;

procedure TMForm.b_dClick(Sender: TObject);
var p,q,f,c,k,d,N, E :longint;
    i:longint;
    msga: array of longint;
    msgas:byte;
    mp_c:mp_int;
    mp_a:mp_int;
    str:string;
begin
   p:=s2i(MForm.e_p.text);
   q:=s2i(MForm.e_q.text);
   n:=p*q;
   F:=(p-1)*(q-1);
   for i:=2 to F do
    if(nod(i,F)=1)then                            //e, n - open key
    begin
       E:=i;
       break;
    end;
   k:=1;
   while ((k*F+1)mod e<>0) do inc(k);
   d:=(k*F+1)div e;                               //d, n - secret key
   MForm.l_other.caption:='N = '+i2s(N)+'  '+
                          'F = '+i2s(F)+'  '+
                          'E = '+i2s(E)+'  '+
                          'K = '+i2s(K)+'  '+
                          'D = '+i2s(D);


   alph:='';
   for i:=1 to length(MForm.e_a.text)   do if((i mod 2)=0)then alph :=alph+ MForm.e_a.text[i];
   mess:='';
   for i:=1 to length(MForm.e_mes.text) do if((i mod 2)=0)then mess :=mess+ MForm.e_mes.text[i];

   with MForm.Memo1.Lines do
   begin
      Clear;

      Add('Зашифровать  несимметричным шифром RSA слово:  «'+MForm.e_mes.text+'»');

      Add('');

      Add('ОТВЕТ:');
      Add('');

      Add('Зашифруем слово «'+MForm.e_mes.text+'»');

      Add('Представим алфавит открытого текста как последовательность целых чисел в диапазоне 1...32.');
      Add('Тогда каждая буква слова будет иметь следующий код(Mi):');
   end;

   msgas:=length(mess);
   setlength(msga,msgas);
   with MForm.l_m do
   begin
      caption:='Mi:';
      for i:=1 to msgas do
      begin
         c:=find_in_a(mess[i]);
         caption:=caption+' '+i2s(ord(c));
         msga[i-1]:=c;

         MForm.Memo1.Lines.add(MForm.e_mes.text[i*2-1]+MForm.e_mes.text[i*2]+' = '+i2s(c));
      end;
   end;

   with MForm.Memo1.Lines do
   begin
      Add('');
      Add('1. Для определения закрытого и открытого ключей, выберем два простых числа:');

      Add('P = '+i2s(P));
      Add('Q = '+i2s(Q));
      Add('');

      Add('2. Определим общую часть для закрытого и открытого ключа, число N = P * Q = '+i2s(p)+' * '+i2s(q)+' = '+i2s(N)+'.');
      Add('');

      Add('3. Рассчитаем функцию Эейлера, F(N) = (P-1) * (Q-1) = '+i2s(p-1)+' * '+i2s(q-1)+' = '+i2s(F)+'.');
      Add('');

      Add('4. Выберем любое случайное число E взаимно простое с F(N), например, пусть E = '+i2s(E)+'.');
      Add('');

      Add('5. Выберем число D, для которого D*C = 1 mod F(N). Например, пусть D = '+i2s(D)+', т. к. '+i2s(D)+'*'+i2s(C)+' = 1 mod '+i2s(F)+'.');
      Add('');

      Add('6. Зашифруем код каждого символа слова, используя открытый ключ E по формуле Mi^E mod N:');
   end;


                //msga[i-1]:=Pow(msga[i-1],E) mod N;
        //
   MForm.e_crtm.text:='';
   for i:=1 to msgas do
   begin
      str:=MForm.e_mes.text[i*2-1]+MForm.e_mes.text[i*2]+'('+i2s(msga[i-1])+') = '+i2s(msga[i-1])+'^'+i2s(E)+' mod '+i2s(N)+' = ';

      mp_init_set_int(mp_a,msga[i-1]);
      mp_init(mp_c);
      mp_expt_int(mp_a,e,mp_c);

      mp_mod_int(mp_c,N,msga[i-1]);

      mp_clear(mp_c);
      mp_clear(mp_a);

      with MForm.e_crtm do text:=text+' '+i2s(msga[i-1]);

      str:= str+i2s(msga[i-1]);

      MForm.Memo1.Lines.add(str);
   end;

   MForm.Memo1.Lines.add('7. Дешифрование осуществляется по формуле Mi^D mod N:');

             //msga[i-1]:=Pow(msga[i-1],d) mod n;
   MForm.e_uncrpt.text:='';
   for i:=1 to msgas do
   begin
      str:=MForm.e_mes.text[i*2-1]+MForm.e_mes.text[i*2]+'('+i2s(msga[i-1])+') = '+i2s(msga[i-1])+'^'+i2s(D)+' mod '+i2s(N)+' = ';

      mp_init_set_int(mp_a,msga[i-1]);
      mp_init(mp_c);

      mp_expt_int(mp_a,d,mp_c);

      mp_mod_int(mp_c,N,msga[i-1]);

      mp_clear(mp_c);
      mp_clear(mp_a);

      str:= str+i2s(msga[i-1]);

      MForm.Memo1.Lines.add(str);

      with MForm.e_uncrpt do text:=text+' '+i2s(msga[i-1]);
   end;
end;

procedure TMForm.FormCreate(Sender: TObject);
begin
end;

procedure TMForm.Memo1Change(Sender: TObject);
begin

end;

end.

